Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetInterface.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetInterface.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetInterface.php	(revision 7265)
@@ -0,0 +1,156 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset;
+
+use Assetic\Filter\FilterInterface;
+
+/**
+ * An asset has a mutable URL and content and can be loaded and dumped.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+interface AssetInterface
+{
+    /**
+     * Ensures the current asset includes the supplied filter.
+     *
+     * @param FilterInterface $filter A filter
+     */
+    public function ensureFilter(FilterInterface $filter);
+
+    /**
+     * Returns an array of filters currently applied.
+     *
+     * @return array An array of filters
+     */
+    public function getFilters();
+
+    /**
+     * Clears all filters from the current asset.
+     */
+    public function clearFilters();
+
+    /**
+     * Loads the asset into memory and applies load filters.
+     *
+     * You may provide an additional filter to apply during load.
+     *
+     * @param FilterInterface $additionalFilter An additional filter
+     */
+    public function load(FilterInterface $additionalFilter = null);
+
+    /**
+     * Applies dump filters and returns the asset as a string.
+     *
+     * You may provide an additional filter to apply during dump.
+     *
+     * Dumping an asset should not change its state.
+     *
+     * If the current asset has not been loaded yet, it should be
+     * automatically loaded at this time.
+     *
+     * @param FilterInterface $additionalFilter An additional filter
+     *
+     * @return string The filtered content of the current asset
+     */
+    public function dump(FilterInterface $additionalFilter = null);
+
+    /**
+     * Returns the loaded content of the current asset.
+     *
+     * @return string The content
+     */
+    public function getContent();
+
+    /**
+     * Sets the content of the current asset.
+     *
+     * Filters can use this method to change the content of the asset.
+     *
+     * @param string $content The asset content
+     */
+    public function setContent($content);
+
+    /**
+     * Returns an absolute path or URL to the source asset's root directory.
+     *
+     * This value should be an absolute path to a directory in the filesystem,
+     * an absolute URL with no path, or null.
+     *
+     * For example:
+     *
+     *  * '/path/to/web'
+     *  * 'http://example.com'
+     *  * null
+     *
+     * @return string|null The asset's root
+     */
+    public function getSourceRoot();
+
+    /**
+     * Returns the relative path for the source asset.
+     *
+     * This value can be combined with the asset's source root (if both are
+     * non-null) to get something compatible with file_get_contents().
+     *
+     * For example:
+     *
+     *  * 'js/main.js'
+     *  * 'main.js'
+     *  * null
+     *
+     * @return string|null The source asset path
+     */
+    public function getSourcePath();
+
+    /**
+     * Returns the URL for the current asset.
+     *
+     * @return string|null A web URL where the asset will be dumped
+     */
+    public function getTargetPath();
+
+    /**
+     * Sets the URL for the current asset.
+     *
+     * @param string $targetPath A web URL where the asset will be dumped
+     */
+    public function setTargetPath($targetPath);
+
+    /**
+     * Returns the time the current asset was last modified.
+     *
+     * @return integer|null A UNIX timestamp
+     */
+    public function getLastModified();
+
+    /**
+     * Returns an array of variable names for this asset.
+     *
+     * @return array
+     */
+    public function getVars();
+
+    /**
+     * Sets the values for the asset's variables.
+     *
+     * @param array $values
+     */
+    public function setValues(array $values);
+
+    /**
+     * Returns the current values for this asset.
+     *
+     * @return array an array of strings
+     */
+    public function getValues();
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetCache.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetCache.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetCache.php	(revision 7265)
@@ -0,0 +1,169 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset;
+
+use Assetic\Cache\CacheInterface;
+use Assetic\Filter\FilterInterface;
+use Assetic\Filter\HashableInterface;
+
+/**
+ * Caches an asset to avoid the cost of loading and dumping.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class AssetCache implements AssetInterface
+{
+    private $asset;
+    private $cache;
+
+    public function __construct(AssetInterface $asset, CacheInterface $cache)
+    {
+        $this->asset = $asset;
+        $this->cache = $cache;
+    }
+
+    public function ensureFilter(FilterInterface $filter)
+    {
+        $this->asset->ensureFilter($filter);
+    }
+
+    public function getFilters()
+    {
+        return $this->asset->getFilters();
+    }
+
+    public function clearFilters()
+    {
+        $this->asset->clearFilters();
+    }
+
+    public function load(FilterInterface $additionalFilter = null)
+    {
+        $cacheKey = self::getCacheKey($this->asset, $additionalFilter, 'load');
+        if ($this->cache->has($cacheKey)) {
+            $this->asset->setContent($this->cache->get($cacheKey));
+
+            return;
+        }
+
+        $this->asset->load($additionalFilter);
+        $this->cache->set($cacheKey, $this->asset->getContent());
+    }
+
+    public function dump(FilterInterface $additionalFilter = null)
+    {
+        $cacheKey = self::getCacheKey($this->asset, $additionalFilter, 'dump');
+        if ($this->cache->has($cacheKey)) {
+            return $this->cache->get($cacheKey);
+        }
+
+        $content = $this->asset->dump($additionalFilter);
+        $this->cache->set($cacheKey, $content);
+
+        return $content;
+    }
+
+    public function getContent()
+    {
+        return $this->asset->getContent();
+    }
+
+    public function setContent($content)
+    {
+        $this->asset->setContent($content);
+    }
+
+    public function getSourceRoot()
+    {
+        return $this->asset->getSourceRoot();
+    }
+
+    public function getSourcePath()
+    {
+        return $this->asset->getSourcePath();
+    }
+
+    public function getTargetPath()
+    {
+        return $this->asset->getTargetPath();
+    }
+
+    public function setTargetPath($targetPath)
+    {
+        $this->asset->setTargetPath($targetPath);
+    }
+
+    public function getLastModified()
+    {
+        return $this->asset->getLastModified();
+    }
+
+    public function getVars()
+    {
+        return $this->asset->getVars();
+    }
+
+    public function setValues(array $values)
+    {
+        $this->asset->setValues($values);
+    }
+
+    public function getValues()
+    {
+        return $this->asset->getValues();
+    }
+
+    /**
+     * Returns a cache key for the current asset.
+     *
+     * The key is composed of everything but an asset's content:
+     *
+     *  * source root
+     *  * source path
+     *  * target url
+     *  * last modified
+     *  * filters
+     *
+     * @param AssetInterface  $asset            The asset
+     * @param FilterInterface $additionalFilter Any additional filter being applied
+     * @param string          $salt             Salt for the key
+     *
+     * @return string A key for identifying the current asset
+     */
+    private static function getCacheKey(AssetInterface $asset, FilterInterface $additionalFilter = null, $salt = '')
+    {
+        if ($additionalFilter) {
+            $asset = clone $asset;
+            $asset->ensureFilter($additionalFilter);
+        }
+
+        $cacheKey  = $asset->getSourceRoot();
+        $cacheKey .= $asset->getSourcePath();
+        $cacheKey .= $asset->getTargetPath();
+        $cacheKey .= $asset->getLastModified();
+
+        foreach ($asset->getFilters() as $filter) {
+            if ($filter instanceof HashableInterface) {
+                $cacheKey .= $filter->hash();
+            } else {
+                $cacheKey .= serialize($filter);
+            }
+        }
+
+        if ($values = $asset->getValues()) {
+            asort($values);
+            $cacheKey .= serialize($values);
+        }
+
+        return md5($cacheKey.$salt);
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/GlobAsset.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/GlobAsset.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/GlobAsset.php	(revision 7265)
@@ -0,0 +1,114 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset;
+
+use Assetic\Util\PathUtils;
+
+use Assetic\Filter\FilterInterface;
+
+/**
+ * A collection of assets loaded by glob.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class GlobAsset extends AssetCollection
+{
+    private $globs;
+    private $initialized;
+
+    /**
+     * Constructor.
+     *
+     * @param string|array $globs   A single glob path or array of paths
+     * @param array        $filters An array of filters
+     * @param string       $root    The root directory
+     * @param array        $vars
+     */
+    public function __construct($globs, $filters = array(), $root = null, array $vars = array())
+    {
+        $this->globs = (array) $globs;
+        $this->initialized = false;
+
+        parent::__construct(array(), $filters, $root, $vars);
+    }
+
+    public function all()
+    {
+        if (!$this->initialized) {
+            $this->initialize();
+        }
+
+        return parent::all();
+    }
+
+    public function load(FilterInterface $additionalFilter = null)
+    {
+        if (!$this->initialized) {
+            $this->initialize();
+        }
+
+        parent::load($additionalFilter);
+    }
+
+    public function dump(FilterInterface $additionalFilter = null)
+    {
+        if (!$this->initialized) {
+            $this->initialize();
+        }
+
+        return parent::dump($additionalFilter);
+    }
+
+    public function getLastModified()
+    {
+        if (!$this->initialized) {
+            $this->initialize();
+        }
+
+        return parent::getLastModified();
+    }
+
+    public function getIterator()
+    {
+        if (!$this->initialized) {
+            $this->initialize();
+        }
+
+        return parent::getIterator();
+    }
+
+    public function setValues(array $values)
+    {
+        parent::setValues($values);
+        $this->initialized = false;
+    }
+
+    /**
+     * Initializes the collection based on the glob(s) passed in.
+     */
+    private function initialize()
+    {
+        foreach ($this->globs as $glob) {
+            $glob = PathUtils::resolvePath($glob, $this->getVars(), $this->getValues());
+
+            if (false !== $paths = glob($glob)) {
+                foreach ($paths as $path) {
+                    if (is_file($path)) {
+                        $this->add(new FileAsset($path, array(), $this->getSourceRoot()));
+                    }
+                }
+            }
+        }
+
+        $this->initialized = true;
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/Iterator/AssetCollectionFilterIterator.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/Iterator/AssetCollectionFilterIterator.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/Iterator/AssetCollectionFilterIterator.php	(revision 7265)
@@ -0,0 +1,84 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset\Iterator;
+
+/**
+ * Asset collection filter iterator.
+ *
+ * The filter iterator is responsible for de-duplication of leaf assets based
+ * on both strict equality and source URL.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class AssetCollectionFilterIterator extends \RecursiveFilterIterator
+{
+    private $visited;
+    private $sources;
+
+    /**
+     * Constructor.
+     *
+     * @param AssetCollectionIterator $iterator The inner iterator
+     * @param array                   $visited  An array of visited asset objects
+     * @param array                   $sources  An array of visited source strings
+     */
+    public function __construct(AssetCollectionIterator $iterator, array $visited = array(), array $sources = array())
+    {
+        parent::__construct($iterator);
+
+        $this->visited = $visited;
+        $this->sources = $sources;
+    }
+
+    /**
+     * Determines whether the current asset is a duplicate.
+     *
+     * De-duplication is performed based on either strict equality or by
+     * matching sources.
+     *
+     * @return Boolean Returns true if we have not seen this asset yet
+     */
+    public function accept()
+    {
+        $asset = $this->getInnerIterator()->current(true);
+        $duplicate = false;
+
+        // check strict equality
+        if (in_array($asset, $this->visited, true)) {
+            $duplicate = true;
+        } else {
+            $this->visited[] = $asset;
+        }
+
+        // check source
+        $sourceRoot = $asset->getSourceRoot();
+        $sourcePath = $asset->getSourcePath();
+        if ($sourceRoot && $sourcePath) {
+            $source = $sourceRoot.'/'.$sourcePath;
+            if (in_array($source, $this->sources)) {
+                $duplicate = true;
+            } else {
+                $this->sources[] = $source;
+            }
+        }
+
+        return !$duplicate;
+    }
+
+    /**
+     * Passes visited objects and source URLs to the child iterator.
+     */
+    public function getChildren()
+    {
+        return new self($this->getInnerIterator()->getChildren(), $this->visited, $this->sources);
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/Iterator/AssetCollectionIterator.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/Iterator/AssetCollectionIterator.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/Iterator/AssetCollectionIterator.php	(revision 7265)
@@ -0,0 +1,110 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset\Iterator;
+
+use Assetic\Asset\AssetCollectionInterface;
+
+/**
+ * Iterates over an asset collection.
+ *
+ * The iterator is responsible for cascading filters and target URL patterns
+ * from parent to child assets.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class AssetCollectionIterator implements \RecursiveIterator
+{
+    private $assets;
+    private $filters;
+    private $output;
+    private $clones;
+
+    public function __construct(AssetCollectionInterface $coll, \SplObjectStorage $clones)
+    {
+        $this->assets  = $coll->all();
+        $this->filters = $coll->getFilters();
+        $this->output  = $coll->getTargetPath();
+        $this->clones  = $clones;
+
+        if (false === $pos = strpos($this->output, '.')) {
+            $this->output .= '_*';
+        } else {
+            $this->output = substr($this->output, 0, $pos).'_*'.substr($this->output, $pos);
+        }
+    }
+
+    /**
+     * Returns a copy of the current asset with filters and a target URL applied.
+     *
+     * @param Boolean $raw Returns the unmodified asset if true
+     * @return \Assetic\Asset\AssetInterface
+     */
+    public function current($raw = false)
+    {
+        $asset = current($this->assets);
+
+        if ($raw) {
+            return $asset;
+        }
+
+        // clone once
+        if (!isset($this->clones[$asset])) {
+            $clone = $this->clones[$asset] = clone $asset;
+
+            // generate a target path based on asset name
+            $name = sprintf('%s_%d', pathinfo($asset->getSourcePath(), PATHINFO_FILENAME) ?: 'part', $this->key() + 1);
+            $clone->setTargetPath(str_replace('*', $name, $this->output));
+        } else {
+            $clone = $this->clones[$asset];
+        }
+
+        // cascade filters
+        foreach ($this->filters as $filter) {
+            $clone->ensureFilter($filter);
+        }
+
+        return $clone;
+    }
+
+    public function key()
+    {
+        return key($this->assets);
+    }
+
+    public function next()
+    {
+        return next($this->assets);
+    }
+
+    public function rewind()
+    {
+        return reset($this->assets);
+    }
+
+    public function valid()
+    {
+        return false !== current($this->assets);
+    }
+
+    public function hasChildren()
+    {
+        return current($this->assets) instanceof AssetCollectionInterface;
+    }
+
+    /**
+     * @uses current()
+     */
+    public function getChildren()
+    {
+        return new self($this->current(), $this->clones);
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/StringAsset.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/StringAsset.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/StringAsset.php	(revision 7265)
@@ -0,0 +1,55 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset;
+
+use Assetic\Filter\FilterInterface;
+
+/**
+ * Represents a string asset.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class StringAsset extends BaseAsset
+{
+    private $content;
+    private $lastModified;
+
+    /**
+     * Constructor.
+     *
+     * @param string $content    The content of the asset
+     * @param array  $filters    Filters for the asset
+     * @param string $sourceRoot The source asset root directory
+     * @param string $sourcePath The source asset path
+     */
+    public function __construct($content, $filters = array(), $sourceRoot = null, $sourcePath = null)
+    {
+        $this->content = $content;
+
+        parent::__construct($filters, $sourceRoot, $sourcePath);
+    }
+
+    public function load(FilterInterface $additionalFilter = null)
+    {
+        $this->doLoad($this->content, $additionalFilter);
+    }
+
+    public function setLastModified($lastModified)
+    {
+        $this->lastModified = $lastModified;
+    }
+
+    public function getLastModified()
+    {
+        return $this->lastModified;
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/AssetManager.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/AssetManager.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/AssetManager.php	(revision 7265)
@@ -0,0 +1,81 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic;
+
+use Assetic\Asset\AssetInterface;
+
+/**
+ * Manages assets.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class AssetManager
+{
+    private $assets = array();
+
+    /**
+     * Gets an asset by name.
+     *
+     * @param string $name The asset name
+     *
+     * @return AssetInterface The asset
+     *
+     * @throws \InvalidArgumentException If there is no asset by that name
+     */
+    public function get($name)
+    {
+        if (!isset($this->assets[$name])) {
+            throw new \InvalidArgumentException(sprintf('There is no "%s" asset.', $name));
+        }
+
+        return $this->assets[$name];
+    }
+
+    /**
+     * Checks if the current asset manager has a certain asset.
+     *
+     * @param string $name an asset name
+     *
+     * @return Boolean True if the asset has been set, false if not
+     */
+    public function has($name)
+    {
+        return isset($this->assets[$name]);
+    }
+
+    /**
+     * Registers an asset to the current asset manager.
+     *
+     * @param string         $name  The asset name
+     * @param AssetInterface $asset The asset
+     *
+     * @throws \InvalidArgumentException If tthe asset name is invalid
+     */
+    public function set($name, AssetInterface $asset)
+    {
+        if (!ctype_alnum(str_replace('_', '', $name))) {
+            throw new \InvalidArgumentException(sprintf('The name "%s" is invalid.', $name));
+        }
+
+        $this->assets[$name] = $asset;
+    }
+
+    /**
+     * Returns an array of asset names.
+     *
+     * @return array An array of asset names
+     */
+    public function getNames()
+    {
+        return array_keys($this->assets);
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/AssetWriter.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/AssetWriter.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/AssetWriter.php	(revision 7265)
@@ -0,0 +1,110 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic;
+
+use Assetic\Util\PathUtils;
+
+use Assetic\Asset\AssetInterface;
+
+/**
+ * Writes assets to the filesystem.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ * @author Johannes M. Schmitt <schmittjoh@gmail.com>
+ */
+class AssetWriter
+{
+    private $dir;
+    private $varValues;
+
+    /**
+     * Constructor.
+     *
+     * @param string $dir The base web directory
+     * @param array  $varValues
+     *
+     * @throws \InvalidArgumentException if a variable value is not a string
+     */
+    public function __construct($dir, array $varValues = array())
+    {
+        foreach ($varValues as $var => $values) {
+            foreach ($values as $value) {
+                if (!is_string($value)) {
+                    throw new \InvalidArgumentException(sprintf('All variable values must be strings, but got %s for variable "%s".', json_encode($value), $var));
+                }
+            }
+        }
+
+        $this->dir = $dir;
+        $this->varValues = $varValues;
+    }
+
+    public function writeManagerAssets(AssetManager $am)
+    {
+        foreach ($am->getNames() as $name) {
+            $this->writeAsset($am->get($name));
+        }
+    }
+
+    public function writeAsset(AssetInterface $asset)
+    {
+        foreach ($this->getCombinations($asset->getVars()) as $combination) {
+            $asset->setValues($combination);
+
+            static::write($this->dir.'/'.PathUtils::resolvePath(
+                $asset->getTargetPath(), $asset->getVars(), $asset->getValues()),
+                $asset->dump());
+        }
+    }
+
+    private function getCombinations(array $vars)
+    {
+        if (!$vars) {
+            return array(array());
+        }
+
+        $combinations = array();
+        $nbValues = array();
+        foreach ($this->varValues as $var => $values) {
+            if (!in_array($var, $vars, true)) {
+                continue;
+            }
+
+            $nbValues[$var] = count($values);
+        }
+
+        for ($i=array_product($nbValues),$c=$i*2; $i<$c; $i++) {
+            $k = $i;
+            $combination = array();
+
+            foreach ($vars as $var) {
+                $combination[$var] = $this->varValues[$var][$k % $nbValues[$var]];
+                $k = intval($k/$nbValues[$var]);
+            }
+
+            $combinations[] = $combination;
+        }
+
+        return $combinations;
+    }
+
+    protected static function write($path, $contents)
+    {
+        if (!is_dir($dir = dirname($path)) && false === @mkdir($dir, 0777, true)) {
+            throw new \RuntimeException('Unable to create directory '.$dir);
+        }
+
+        if (false === @file_put_contents($path, $contents)) {
+            throw new \RuntimeException('Unable to write file '.$path);
+        }
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Cache/ConfigCache.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Cache/ConfigCache.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Cache/ConfigCache.php	(revision 7265)
@@ -0,0 +1,123 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Cache;
+
+/**
+ * A config cache stores values using var_export() and include.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class ConfigCache
+{
+    private $dir;
+
+    /**
+     * Construct.
+     *
+     * @param string $dir The cache directory
+     */
+    public function __construct($dir)
+    {
+        $this->dir = $dir;
+    }
+
+    /**
+     * Checks of the cache has a file.
+     *
+     * @param string $resource A cache key
+     *
+     * @return Boolean True if a file exists
+     */
+    public function has($resource)
+    {
+        return file_exists($this->getSourcePath($resource));
+    }
+
+    /**
+     * Writes a value to a file.
+     *
+     * @param string $resource A cache key
+     * @param mixed  $value    A value to cache
+     */
+    public function set($resource, $value)
+    {
+        $path = $this->getSourcePath($resource);
+
+        if (!is_dir($dir = dirname($path)) && false === @mkdir($dir, 0777, true)) {
+            // @codeCoverageIgnoreStart
+            throw new \RuntimeException('Unable to create directory '.$dir);
+            // @codeCoverageIgnoreEnd
+        }
+
+        if (false === @file_put_contents($path, sprintf("<?php\n\n// $resource\nreturn %s;\n", var_export($value, true)))) {
+            // @codeCoverageIgnoreStart
+            throw new \RuntimeException('Unable to write file '.$path);
+            // @codeCoverageIgnoreEnd
+        }
+    }
+
+    /**
+     * Loads and returns the value for the supplied cache key.
+     *
+     * @param string $resource A cache key
+     *
+     * @return mixed The cached value
+     */
+    public function get($resource)
+    {
+        $path = $this->getSourcePath($resource);
+
+        if (!file_exists($path)) {
+            throw new \RuntimeException('There is no cached value for '.$resource);
+        }
+
+        return include $path;
+    }
+
+    /**
+     * Returns a timestamp for when the cache was created.
+     *
+     * @param string $resource A cache key
+     *
+     * @return integer A UNIX timestamp
+     */
+    public function getTimestamp($resource)
+    {
+        $path = $this->getSourcePath($resource);
+
+        if (!file_exists($path)) {
+            throw new \RuntimeException('There is no cached value for '.$resource);
+        }
+
+        if (false === $mtime = @filemtime($path)) {
+            // @codeCoverageIgnoreStart
+            throw new \RuntimeException('Unable to determine file mtime for '.$path);
+            // @codeCoverageIgnoreEnd
+        }
+
+        return $mtime;
+    }
+
+    /**
+     * Returns the path where the file corresponding to the supplied cache key can be included from.
+     *
+     * @param string $resource A cache key
+     *
+     * @return string A file path
+     */
+    private function getSourcePath($resource)
+    {
+        $key = md5($resource);
+
+        return $this->dir.'/'.$key[0].'/'.$key.'.php';
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Cache/ExpiringCache.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Cache/ExpiringCache.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Cache/ExpiringCache.php	(revision 7265)
@@ -0,0 +1,60 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Cache;
+
+/**
+ * Adds expiration to a cache backend.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class ExpiringCache implements CacheInterface
+{
+    private $cache;
+    private $lifetime;
+
+    public function __construct(CacheInterface $cache, $lifetime)
+    {
+        $this->cache = $cache;
+        $this->lifetime = $lifetime;
+    }
+
+    public function has($key)
+    {
+        if ($this->cache->has($key)) {
+            if (time() < $this->cache->get($key.'.expires')) {
+                return true;
+            }
+
+            $this->cache->remove($key.'.expires');
+            $this->cache->remove($key);
+        }
+
+        return false;
+    }
+
+    public function get($key)
+    {
+        return $this->cache->get($key);
+    }
+
+    public function set($key, $value)
+    {
+        $this->cache->set($key.'.expires', time() + $this->lifetime);
+        $this->cache->set($key, $value);
+    }
+
+    public function remove($key)
+    {
+        $this->cache->remove($key.'.expires');
+        $this->cache->remove($key);
+    }
+}
